@ECHO OFF
BAX %0 %1 %2 %3 %4 %5 %6 %7 %8 %9
GOTO SKIPBAX
'******************************************************************
'* This is the most complex of the environment variable editors   *
'* on the BAX distribution disk.  We did a little extra work on   *
'* the "greeting box" and actually drew lines around it with the  *
'* so called "box drawing characters".                            *
'*                                                                *
'* ENVED gives you a chance to edit each variable in your         *
'* environment.  When you are done with one, the next one pops up *
'* for editing.  If you don't actually want to make changes to    *
'* any of them, keep pressing ESCAPE.  ENVED will terminate when  *
'* there are no more environment variables left to edit.          *
'******************************************************************
=ENVED
%BOXUL = CHARS 201
%BOXLL = CHARS 200
%BOXUR = CHARS 187
%BOXLR = CHARS 188
%BOXVL = CHARS 186
%BOXHL = CHARS 205
'
%A1  = LIT #**********************************************************$
%A2  = LIT *             DOS ENVIRONMENT VARIABLE EDITOR              *
%A3  = LIT *                                                          *
%A4  = LIT * PRESS ESCAPE TO SKIP A VARIABLE WITHOUT MAKING CHANGES.  *
%A5  = LIT *                                                          *
%A6  = LIT * PRESS ENTER TO SAVE CHANGES.                             *
%A7  = LIT *                                                          *
%A8  = LIT * BLANK OUT THE LINE AND PRESS ENTER TO TERMINATE ENVED.   *
%A9  = LIT *                                                          *
%A10 = LIT * TO ERASE A VARIABLE, BLANK OUT EVERYTHING AFTER          *
%A11 = LIT * THE EQUAL SIGN.  THEN PRESS ENTER.                       *
%A12 = LIT *                                                          *
%A13 = LIT * TO CREATE A NEW VARIABLE, EDIT THE NAME OF ANY OF        *
%A14 = LIT * THE DISPLAYED VARIABLES, FOLLOW IT WITH AN EQUAL SIGN    *
%A15 = LIT * AND THE VALUE TO BE ASSIGNED TO IT.  THEN PRESS ENTER.   *
%A16 = LIT #**********************************************************$
%A17 = %N
'
%XX = JOIN %BOXUL %BOXHL %BOXUR      ' PUT GOOD CORNERS ON THE BOX
%A1  = TRANS %A1 #*$ %XX
%XX = JOIN %BOXLL %BOXHL %BOXLR
%A16 = TRANS %A16 #*$ %XX
'
CALL =COLORSUB                       ' ASSIGN NAMES FOR COLORS
COLORS %BLACK %BROWN                 ' UNDERLYING SCREEN IS BROWN
CLS                                  ' PAINT THE SCREEN BROWN
COLORS %RED  %WHITE                  ' OUR BOX COLOR
%X = 0                               ' SET LOOP COUNTER
LOOP =BOTBOX                         ' TOP OF LOOP TO DRAW BOX
%X = ADD %X 1                        ' INCREMENT COUNTER
%XX = TRANS %A%X * %BOXVL            ' PUT VERTICAL LINES ON THE BOX
CURSORVH 0 12                        ' INDENT 12 SPACES
OUTMSG %XX                           ' DISPLAY TEXT ON SCREEN
OUTPUT                               ' MOVE CURSOR DOWN
IF %A%X = %N THEN LEAVE =BOTBOX      ' BREAK LOOP IF NULL STRING
%A%X = %N                            ' SAVE A LITTLE STRING SPACE
=BOTBOX                              ' BOTTOM OF LOOP
%CURLINE = CURSORV                   ' LINE WHERE CURSOR IS SITTING
%BLANKS = RPT 80 %B                  ' LINE OF 80 BLANKS
'
%C = ENVGET P                        ' GET ALL PARENT ENV VARS
%X = 0                               ' SET OUR LOOP COUNTER
LOOP =NOMORE                         ' TOP OF LOOP
%X = ADD %X 1                        ' INCREMENT COUNTER
IF %X > %C THEN LEAVE =NOMORE        ' NO MORE VARS TO EDIT
%P = %A%X                            ' FOR SIMPLER SYNTAX
%STRLEN = LEN %P
IF %STRLEN <= 80 THEN GOTO =LENOK
CURSORVH 23 1
OUTPUT %BLANKS
CURSORVH 23 1
%XX = LEFT %P 20
OUTMSG SKIPPING VARIABLE %XX ........................ TOO LONG TO EDIT
GOTO =NOMORE
=LENOK
'
%P = LEFT %P 80                      ' PAD BLANKS ON RIGHT
COLORS %BLACK %BROWN                 ' UNDERLYING COLOR
CURSORVH %CURLINE 1                  ' WIPE OUT PREVIOUS CONTENTS OF LINE
OUTPUT %BLANKS                       ' WITH LINE OF 80 BLANKS
CURSORVH %CURLINE 1                  ' INPUT AREA STARTS IN COLUMN 1
COLORS %YELLOW %MAGENTA              ' COLORS FOR INPUT AREA
INPUT %P                             ' LET OUR USER CHANGE THE VARIABLE
IF %EOI = 1 THEN GOTO =NOMORE        ' USER PRESSED ESC KEY -- NO CHANGE
%P = TRIM %P                         ' REMOVE LEADING/TRAILING BLANKS
IF %P = %N THEN LEAVE =NOMORE        ' TERMINATE IF NULL ENTRY
%E = LOC %P =                        ' FIND EQUAL SIGN
IF %E < 2 THEN LEAVE =NOMORE         ' TERMINATE IF NO EQUAL SIGN OR
                                     ' IF IT IS FIRST CHAR
%J = SUB %E 1                        ' NUMBER OF CHARS BEFORE = SIGN
%VN = LEFT %P %J                     ' VARIABLE NAME
%J = ADD %E 1                        ' POINT TO CHAR FOLLOWING = SIGN
%LL = LEN %P                         ' LENGTH OF STRING
'
IF %J <= %LL THEN %VV = MID %P %J ELSE %VV = %N
'
ENVSET P %VN %VV                     ' WRITE NEW ENV VARIABLE
CURSORVH 21 1
COLORS %YELLOW %RED
OUTMSG ********* NEW VALUE FOR %VN HAS BEEN SET *********
'
=NOMORE
OUTPUT            ' MOVE CURSOR DOWN ONE LINE
STOP
'
=COLORSUB         ' SUB-ROUTINE TO ASSIGN MEANINGFUL NAMES TO COLORS
'
%BLACK    =  0    ' NOTE: IF YOU ADD 8 TO ANY OF THESE YOU
%BLUE     =  1    ' WILL GET THE SAME COLOR, ONLY BRIGHTER.
%GREEN    =  2
%CYAN     =  3
%RED      =  4
%MAGENTA  =  5
%BROWN    =  6
%WHITE    =  7
'                  **** BRIGHTER COLORS ****
%GRAY     =  8     ' A BRIGHT BLACK IS GRAY
%BLUEX    =  9
%GREENX   = 10     ' BRIGHT COLORS MAY ONLY BE USED IN THE FOREGROUND
%CYANX    = 11
%REDX     = 12
%MAGENTAX = 13
%YELLOW   = 14     ' A BRIGHT BROWN IS YELLOW
%WHITEX   = 15
'
RETURN
END
:SKIPBAX
