$COMPILE EXE
$COM 0
$CPU 8086
$LIB ALL OFF
$SOUND 1
'
DEFINT A-Z                        'DEFAULT DATA TYPE IS INTEGER
'
ON ERROR GOTO ABNORMAL  'LET BASIC TRAP MOST OF THE ERRORS
'
DIM V$(40)                        'ARRAY TO HOLD INPUT ITEMS AS STRINGS
DIM V#(40)                        'ARRAY TO HOLD NUMERIC VALUES
B$ = " "                          'SINGLE BLANK
N$ = ""                           'NULL STRING
ERRCODE = 0                       'NORMAL TERMINATION CODE IF NO ERRORS
T = 0                             'INITIALIZE COUNT OF THE INPUT ITEMS
A$ = LTRIM$(RTRIM$(COMMAND$))     'CLEAN UP COMMAND LINE
A$ = UCASE$(A$)                   'MAKE SURE WE HAVE UPPER CASE ONLY
'
DO                                'LOOP TO PARSE OUT DATA ITEMS
I = INSTR(A$,B$)                  'LOOK FOR AN IMBEDDED BLANK
INCR T                            'INCREMENT OUR ITEM COUNT
'
   IF I = 0 THEN                  'HAS TO BE THE LAST ONE --
   V$(T) = A$                     'SO USE THE REST OF THE STRING --
   EXIT LOOP                      'AND EXIT FROM THE LOOP
   ELSE                           'FOUND AN IMBEDDED BLANK --
   V$(T) = LEFT$(A$,I - 1)        'SO EXTRACT UP TO IT --
   A$ = MID$(A$,I + 1)            'AND REMOVE THE ITEM FROM FRONT
   A$ = LTRIM$(A$)                'REMOVE ANY LEADING BLANKS --
   END IF
LOOP                              'AND LOOP BACK TO DO ANOTHER ONE
'
BAXSEG = VAL(V$(T))               'SEGMENT OF OUR CALLER'S WORK AREA
DECR T                            'ADJUST ITEM COUNT DOWN ONE
IF BAXSEG = 0 THEN GOTO BADSEG
'
BAXOFF = 0                        'OFFSET (ALWAYS 0)
'
DPLACES = 2                       'DEFAULT NUMBER OF PLACES RIGHT OF DP
DP$ = "."                         'DECIMAL POINT STRING
'
FOR X = 1 TO T                    'LOOP TO TEST EACH ITEM
I = INSTR(V$(X),DP$)              'LOOK FOR DECIMAL POINT
IF I > 0 THEN                     'IF IT HAS ONE THEN --
L = LEN(V$(X))                    'GET LENGTH OF STRING --
K = L - I                         'AND CALCULATE NUMBER OF PLACES
IF K > DPLACES THEN DPLACES = K   'ADJUST DEFAULT UP IF NECESSARY
END IF
NEXT X                            'LOOP BACK AND DO ANOTHER
'
FS$ = STRING$(12,"#") + DP$ + STRING$(DPLACES,"#") 'FORMAT STRING
'
FOR X = 1 TO T STEP 3               'LOOP THRU AND MAKE CALCS
OP$ = LEFT$(V$(X),1)                'OP CODE IS ITEM 1 , 4 , 7 , 10 , ETC
V#(X + 1) = VAL(V$(X + 1))          'FIRST VALUE FOR CALC
V#(X + 2) = VAL(V$(X + 2))          'SECOND VALUE FOR CALC
'
IF OP$ = "A" THEN                   'ADD
V#(X) = V#(X + 1) + V#(X + 2)
'
ELSEIF OP$ = "S" THEN               'SUBTRACT
V#(X) = V#(X + 1) - V#(X + 2)
'
ELSEIF OP$ = "M" THEN               'MULTIPLY
V#(X) = V#(X + 1) * V#(X + 2)
'
ELSEIF OP$ = "D" THEN               'DIVIDE
     IF V#(X + 2) = 0 THEN
     ERRCODE = 3
     E$ = "ERROR: DIVISION BY ZERO"
     ELSE
     V#(X) = V#(X + 1) / V#(X + 2)
     END IF
'
ELSEIF OP$ = "E" THEN               'EXPONENTIATE
     IF V#(X + 2) < 0 THEN
     ERRCODE = 4
     E$ = "ERROR: NEGATIVE EXPONENTS NOT ALLOWED"
     ELSE
     V#(X) = V#(X + 1) ^ V#(X + 2)
     END IF
'
ELSE                                'ERROR -- BAD OP CODE
ERRCODE = 2
E$ = "ERROR: BAD OPERATION CODE -- MUST BE A,S,M,D OR E"
END IF
'
IF ERRCODE > 0 THEN GOTO ABNORMAL   'TERMINATE WITH ERROR FLAG SET
'
NEXT X
'
O$ = N$                             'INITIALIZE OUTPUT STRING TO NULL
FOR X = 1 TO T STEP 3               'LOOP THRU CALCULATED VALUES
TEMP$ = LTRIM$(USING$(FS$,V#(X)))   'FORMAT EACH VALUE
O$ = O$ + TEMP$ + B$                'PUT IT IN THE OUTPUT STRING
NEXT X                              'GO BACK AND DO THE NEXT ONE
'
DEF SEG = BAXSEG        'POINT TO BAX SEGMENT
POKE$ BAXOFF , O$       'MOVE OUR OUTPUT STRING INTO THE BAX SEGMENT
DEF SEG                 'RESTORE DEFAULT SEGMENT (NOT REALLY NECESSARY)
'
END ERRCODE             'NORMAL TERMINATION
'
BADSEG:                 'SEGMENT INFO IS BAD
ERRCODE = 1
E$ = "ERROR: BAD SEGMENT VALUE"
'
ABNORMAL:               '******** ERRORS BRANCH HERE ***********
IF ERRCODE = 0 THEN     'USE BASIC ERRORCODE IF BASIC ERROR
ERRCODE = ERR
O$ = "ERROR: SYSTEM ERROR CODE = " + STR$(ERRCODE)
ELSE
O$ = E$
END IF
PRINT O$
END ERRCODE
